# we want to install in /sbin, not /usr/sbin...
%define _exec_prefix %{nil}
%define _sbindir /sbin
%define _usrsbindir /usr/sbin
#define git %{nil}

Name:		mdadm
Version:	3.2.5
Release:	2
Summary:	A tool for managing Soft RAID under Linux
Group:		System/Kernel and hardware
License:	GPLv2+
URL:		http://www.kernel.org/pub/linux/utils/raid/mdadm/
Source0:	http://www.kernel.org/pub/linux/utils/raid/mdadm/mdadm-%{!?git:%version}%{?git:%git}.tar.xz
%if %{?git:0}%{?!git:1}
Source1:	http://www.kernel.org/pub/linux/utils/raid/mdadm/mdadm-%{version}.tar.sign
%endif
Patch0:		mdadm-3.2.5-fix-build.diff
# From Fedora, slightly modified
Patch1:		mdadm-3.2.3-udev.patch
# don't use -Werror flag
Patch2:		mdadm-3.2.4-mdv-no_werror.patch
# From Fedora, slightly modified
Source2:	mdadm.init
# From Fedora
Source3:	mdadm-raid-check
Source4:	mdadm-raid-check-sysconfig
Source5:	mdadm-cron
# From Fedora, modified because our initscripts do not use incremental assembly
# modification can be reverted only _after_ initscripts has been fixed and a
# conflict for older inistcripts is added (bluca)
Source6:	mdadm.rules
Source7:	mdmonitor.service
Source8:	mdmonitor-takeover.service
Source9:	%{name}-tmpfiles.conf
#
Requires(post):	rpm-helper
Requires(preun):	rpm-helper
# udev rule used to be in udev package
Conflicts:	udev < 145-2
BuildRequires:	groff
BuildRequires:	binutils-devel
%if %mdvver >= 201200
BuildRequires:	systemd-units
%endif

%description
mdadm is a program that can be used to create, manage, and monitor
Linux MD (Software RAID) devices.

As such is provides similar functionality to the raidtools packages.
The particular differences to raidtools is that mdadm is a single
program, and it can perform (almost) all functions without a
configuration file (that a config file can be used to help with
some common tasks).

%prep
%setup -q %{?git:-n %name}
%apply_patches

echo "PROGRAM %{_sbindir}/mdadm-syslog-events" >> mdadm.conf-example

%build
%setup_compile_flags
make SYSCONFDIR="%{_sysconfdir}" CXFLAGS="%{optflags}"

%install
%makeinstall_std MANDIR=%{_mandir} BINDIR=%{_sbindir}

install -Dp -m 644 mdadm.conf-example %{buildroot}%{_sysconfdir}/mdadm.conf
install -Dp %{SOURCE2} %{buildroot}%{_initrddir}/mdadm
install -Dp %{SOURCE3} %{buildroot}%{_usrsbindir}/raid-check
install -Dp -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/sysconfig/raid-check
install -Dp -m 644 %{SOURCE5} %{buildroot}%{_sysconfdir}/cron.d/raid-check
install -Dp misc/syslog-events %{buildroot}%{_sbindir}/mdadm-syslog-events
install -Dp -m 644 %{SOURCE6} %{buildroot}/lib/udev/rules.d/65-md-incremental.rules

%if %mdvver >= 201200
install -d -m 755 %{buildroot}%{_unitdir}
install -m 644 %{SOURCE7} %{buildroot}%{_unitdir}
install -m 644 %{SOURCE8} %{buildroot}%{_unitdir}
ln -s mdmonitor.service %{buildroot}%{_unitdir}/mdadm.service
install -D -m 644 %{SOURCE9} %{buildroot}%{_prefix}/lib/tmpfiles.d/%{name}.conf
rm -rf %{buildroot}%{_initrddir}/mdadm
%endif

%post
%if %mdvver >= 201200
systemd-tmpfiles --create %{name}.conf
%endif
%_post_service mdadm

%preun
%_preun_service mdadm

%files
%doc TODO ChangeLog README.initramfs ANNOUNCE*
%{_sbindir}/mdadm
%{_sbindir}/mdadm-syslog-events
%{_sbindir}/mdmon
%{_usrsbindir}/raid-check
%config(noreplace) %{_sysconfdir}/cron.d/raid-check
%config(noreplace,missingok) %{_sysconfdir}/mdadm.conf
%config(noreplace) %{_sysconfdir}/sysconfig/raid-check
/lib/udev/rules.d/64-md-raid.rules
/lib/udev/rules.d/65-md-incremental.rules
%if %mdvver >= 201200
%{_unitdir}/*.service
%{_prefix}/lib/tmpfiles.d/%{name}.conf
%else
%{_initrddir}/mdadm
%endif
%{_mandir}/man*/md*


%changelog
* Sun Sep 23 2012 Tomasz Pawel Gajc <tpg@mandriva.org> 3.2.5-2
+ Revision: 817375
- fix install
- fix install
- spec file clean
- add support for systemd (synced with Mageia)

* Fri Jun 08 2012 Dmitry Mikhirev <dmikhirev@mandriva.org> 3.2.5-1
+ Revision: 803339
- update to 3.2.5

* Thu May 10 2012 Dmitry Mikhirev <dmikhirev@mandriva.org> 3.2.4-1
+ Revision: 797942
- update to 3.2.4
- remove obsolete upstream patches

  + Oden Eriksson <oeriksson@mandriva.com>
    - sync with mdadm-3.2.3-4.mga2.src.rpm

* Sat Jun 18 2011 Funda Wang <fwang@mandriva.org> 3.2.2-1
+ Revision: 685891
- new version 3.2.2

* Thu Jun 16 2011 Luca Berra <bluca@mandriva.org> 3.2.1-2
+ Revision: 685465
- new version 3.2.1
- resync raid check and mdadm init scripts with fedora
  	- Don't report mismatch counts on either raid1 or raid10
  	- Check both active and idle arrays during raid check runs
  	- Move the raid-check script from cron.weekly to /usr/sbin, add a
  	  crontab file to /etc/cron.d and mark it config(noreplace).  This way
  	  users can select their own raid-check frequency and have it honored
  	  through upgrades.
  	- Allow the raid-check script to set the process and io priority of the
  	  thread performing the check in order to preserve responsiveness of the
  	  machine during the check.
- split udev rules in two files like fedora, but honor dracut rd.md.imsm=0 kernel command line and keep /dev/.in_sysinit hack
- revert -Werror removal, please don't _ever_ remove it again
- add patch from fedora to fix build with -Wno-unused-parameter
- add two patches to fix build with -Wstrict-aliasing
- remove container-stop patch merged upstream

* Fri May 06 2011 Funda Wang <fwang@mandriva.org> 3.1.5-2
+ Revision: 669919
- disable werror

  + Oden Eriksson <oeriksson@mandriva.com>
    - mass rebuild

* Fri Mar 25 2011 Oden Eriksson <oeriksson@mandriva.com> 3.1.5-1
+ Revision: 648482
- 3.1.5
- drop mdadm-3.1.4-imsm-create-segfault.patch, it was applied upstream

* Sun Dec 12 2010 Luca Berra <bluca@mandriva.org> 3.1.4-2mnb2
+ Revision: 620609
- add udev patch again
- fix a segfault in mdadm -C --metadata=imsm
- try to workaround mdadm -Ss not always stopping container

* Tue Aug 31 2010 Thomas Backlund <tmb@mandriva.org> 3.1.4-1mnb2
+ Revision: 574669
- update to 3.1.4
- drop P3-P7 (merged)

* Sat Aug 21 2010 Thomas Backlund <tmb@mandriva.org> 3.1.3-1mnb2
+ Revision: 571551
- update to 3.1.3
- drop P1, P2 (not needed anymore)
- Fix compiler warning concering bad use of snprintf (P3)
- Don't link mdadm with pthreads, only mdmon needs it (P4)
- Incremental: return success in 'container not enough' case (P5)
- Incremental: accept '--no-degraded' as a deprecated option (P6)
- Allow --incremental to add spares to an array (P7)

* Tue Mar 16 2010 Luca Berra <bluca@mandriva.org> 3.1.2-1mnb2
+ Revision: 522402
- update to final 3.1.2

* Sun Mar 07 2010 Luca Berra <bluca@mandriva.org> 3.1.1-1mnb2
+ Revision: 515442
- update to latest git
- use only /dev/.mdadm for mdmon pid/socket
- reflect the change in man pages
- only takeover mdmon once
- use syslog-events as default "PROGRAM" for mdadm --monitor
- more mdmon fixes
- update to latest git (3.1.1) + patches

* Tue Dec 29 2009 Luca Berra <bluca@mandriva.org> 3.0.3-2mnb2
+ Revision: 483236
- Add 13 imsm related patches from latest git
- update to mdadm 3.0.3
  drop patches merged upstream
  drop unused static patch
  sync with fedora
- Fix display of metadata version in output of Detail mode
- Add UUID output to --detail --export (bz523314)
- Add a patch fixing mdadm --detail -export segfaults (bz526761, bz523862)
- Add a patch making mdmon store its state under /dev/.mdadm for initrd mdmon, rootfs mdmon handover
- Restart mdmon from initscript (when running) for rootfs mdmon handover
- Fix a problem in the raid-check script (bz523000)
- Fix the intel superblock handler so we can test on non-scsi block devices
- Drop the endian patch because it no longer applied cleanly and all attempts to reproduce the original problem as reported in bz510605 failed
- Update the mdmonitor init script for LSB compliance (bz527957)

* Mon Dec 07 2009 Pascal Terjan <pterjan@mandriva.org> 3.0.2-3mnb2
+ Revision: 474359
- Workaround build failure due to bug #56246

* Thu Oct 08 2009 Luca Berra <bluca@mandriva.org> 3.0.2-2mnb2
+ Revision: 455998
- Fix null-dereference in set_member_info

* Fri Sep 25 2009 Frederik Himpe <fhimpe@mandriva.org> 3.0.2-1mnb2
+ Revision: 449106
- update to new version 3.0.2

* Thu Sep 03 2009 Pascal Terjan <pterjan@mandriva.org> 3.0-4mnb2
+ Revision: 428322
- Add missing space in mdadm --detail --brief

* Fri Jul 31 2009 Anssi Hannula <anssi@mandriva.org> 3.0-3mnb2
+ Revision: 405012
- add conflicts with old udev due to the rules file

* Fri Jul 31 2009 Luca Berra <bluca@mandriva.org> 3.0-2mnb2
+ Revision: 405002
- use udev rule shipped with mdadm, with check to avoid race with rc.sysinit
- remove mdmpd from source rpm
- remove mdassemble, it is not used anymore, we are also not building any static binary
- fix endian bug in uuid generation (fedora)
- add script to do periodic checks on arrays (fedora)
- sync initscript with fedora
- misc spec updates (rpmlint)
- update udev rules (from fedora) fixes nasty race that would result in
  degraded arrays at boot

  + Pascal Terjan <pterjan@mandriva.org>
    - Update to 3.0

* Tue Mar 10 2009 Thomas Backlund <tmb@mandriva.org> 2.6.9-1mnb2
+ Revision: 353513
- update to 2.6.9
- rediff patch5

* Sun Dec 21 2008 Oden Eriksson <oeriksson@mandriva.com> 2.6.8-1mnb2
+ Revision: 317090
- 2.6.8
- drop upstream implemented patches;
  P6: fix parameters to open calls (from Fedora)
  P7: fix raid10 NULL pointer oops
- rediffed some fuzzy patches (P0,P4)
- redefine %%{_sbindir} to /sbin

* Mon Nov 03 2008 Thomas Backlund <tmb@mandriva.org> 2.6.7-2mnb2
+ Revision: 299593
- add P7: fix raid10 NULL pointer oops

* Thu Jul 24 2008 Olivier Blin <blino@mandriva.org> 2.6.7-1mnb2
+ Revision: 245826
- buildrequire glibc-static-devel (for the about useless static patch)
- update udev rules to run degraded arrays and get additional info
  about arrays being assembled (from Fedora)
- fix parameters to open calls (from Fedora)
- add build fixes from Fedora
- update license tag
- update URL
- 2.6.7 (with incrematal assembly fixes that should fix #40023)
- use s390 patch from RH to disable Werror (instead of our hack in setup)
- remove udev patch, upstream mdadm should now be udev friendly
- add cflags patch from Fedora
- add static patch from Fedora (easier to apply other patches on top)
- renumber mdmpd patches

* Wed Jun 11 2008 Oden Eriksson <oeriksson@mandriva.com> 2.6.4-3mnb2
+ Revision: 217954
- fix "error: Missing %%files for subpackage mdmpd"
- rebuilt against dietlibc-devel-0.32

* Mon Feb 18 2008 Thierry Vignaud <tv@mandriva.org> 2.6.4-2mnb1
+ Revision: 170655
- replace %%mkrel with %%manbo_mkrel for Manbo Core 1
- fix no-buildroot-tag

* Thu Feb 07 2008 Olivier Blin <blino@mandriva.org> 2.6.4-2mdv2008.1
+ Revision: 163837
- add a udev rules file for device assembly (from RH #429604)

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Nov 10 2007 David Walluck <walluck@mandriva.org> 2.6.4-1mdv2008.1
+ Revision: 107333
- 2.6.4

* Wed Sep 05 2007 David Walluck <walluck@mandriva.org> 2.6.3-4mdv2008.0
+ Revision: 79667
- set CXFLAGS directly in Makefile
- disable -fstack-protector

* Tue Aug 28 2007 Andreas Hasenack <andreas@mandriva.com> 2.6.3-2mdv2008.0
+ Revision: 72335
- rebuild to fix mdassemble segfault

* Mon Aug 20 2007 David Walluck <walluck@mandriva.org> 2.6.3-1mdv2008.0
+ Revision: 68044
- 2.6.3

* Mon May 21 2007 David Walluck <walluck@mandriva.org> 2.6.2-2mdv2008.0
+ Revision: 29526
- add patch to fix -Werror
- clean up patch list
- remove some spurious BuildRequires
- 2.6.2
- some spec reoganization

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - don't use -Werror on sparc either
    - parallell build


* Fri Mar 09 2007 David Walluck <walluck@mandriva.org> 2.6.1-1mdv2007.1
+ Revision: 138616
- 2.6.1

* Mon Jan 15 2007 David Walluck <walluck@mandriva.org> 2.6-1mdv2007.1
+ Revision: 108996
- 2.6

* Thu Dec 14 2006 Emmanuel Andry <eandry@mandriva.org> 2.5.6-2mdv2007.1
+ Revision: 96855
- rebuild

* Wed Dec 13 2006 Emmanuel Andry <eandry@mandriva.org> 2.5.6-1mdv2007.1
+ Revision: 96579
- New version 2.5.6
  drop patches 15 and 16 (applied upstream)

* Fri Sep 15 2006 Luca Berra <bluca@mandriva.org> 2.5.3-3mdv2007.0
+ Revision: 61509
- make mdasseble also enable read-write
- fix a bug in mdassemble that prevented activation of stacked arrays (#25459)
- do not fail when autoassembling everything and some md are already active
- make mdmpd build again (Oden)
  but make it a subpackage and disabled by default
- new upstream version 2.5.3

* Fri Jul 07 2006 Luca Berra <bluca@mandriva.org> 2.5.2-1mdv2007.0
+ Revision: 38423
- updated p14 to deal with new location of udev db
- new upstream version 2.5.2
  remove patches integrated upstream
- new upstream version 2.5.1
  remove patches integrated upstream
- automatically create devices if using udev (p14)
- add p12 and p13 from git
- use %%bcond for conditional build options
- * Mon Jun 19 2006 Christiaan Welvaart <cjw@daneel.dyndns.org>
- Fix using ++ in a macro argument.
- remove patches merged upstream
- New Upstream version 2.5.1
- New Upstream version 2.5.1
- uncompressed scripts
- import mdadm-2.5-1mdv2007.0

* Mon May 29 2006 Oden Eriksson <oeriksson@mandriva.com> 2.5-2mdv2007.0
- use provided sha1 (and don't link against openssl...)

* Sun May 28 2006 Luca Berra <bluca@vodka.it> 2.5-1mdv2007.0
- New release 2.5
- rework p14 to remove more warnings
- use posix rand() function instead of BSD random() (p15)
- fix some issue with mdassemble (p16)
- mdassemble does not need to parse auto=

* Sun May 28 2006 Luca Berra <bluca@vodka.it> 2.4.1-1mdv2007.0
- New release 2.4.1

* Sat May 27 2006 Luca Berra <bluca@vodka.it> 2.4-1mdv2007.0
- New release 2.4
- snprintf fix (p11)
- another strict-aliasing fix (p12)
- add a debug message to Grow.c and remove a gcc warning (p14)
- remove mkinitramfs script, we have our own mkinitrd/mkinitramfs.

* Fri Apr 21 2006 Per yvind Karlsen <pkarlsen@mandriva.com> 2.3.1-3mdk
- build against dietlibc on sparc
- fix executable-marked-as-config-file

* Sat Feb 18 2006 Christiaan Welvaart <cjw@daneel.dyndns.org> 2.3.1-2mdk
- Patch13: fix #include for kernel byteswap functions

* Mon Feb 06 2006 Luca Berra <bluca@vodka.it> 2.3.1-1mdk
- New Release 2.3.1
- re-enable strict aliasing in CFLAGS (fixed upstream)
- remove p11 merged upstream

* Sat Feb 04 2006 Luca Berra <bluca@vodka.it> 2.3-1mdk
- New Release 2.3
- remove p11 and p12 merged upstream
- disable strict aliasing in CFLAGS
- x86_64 fix (p11)

* Thu Jan 26 2006 Luca Berra <bluca@vodka.it> 2.2-4mdk
- rework UUID update patch (p11)
- add another typo patch to super1.c (p12)

* Mon Jan 09 2006 Olivier Blin <oblin@mandriva.com> 2.2-3mdk
- convert parallel init to LSB

* Wed Jan 04 2006 Luca Berra <bluca@vodka.it> 2.2-2mdk
- add UUID update patch

* Mon Jan 02 2006 Thierry Vignaud <tvignaud@mandriva.com> 2.2-1mdk
- new release
- install new mkinitramfs

* Mon Jan 02 2006 Thierry Vignaud <tvignaud@mandriva.com> 1.12.0-4mdk
- rollback, mdadm doesn't need harddrake service to be run before
- add parallel init support to mdmpd

* Mon Jan 02 2006 Olivier Blin <oblin@mandriva.com> 1.12.0-3mdk
- parallel init support

* Sun Jan 01 2006 Mandriva Linux Team <http://www.mandrivaexpert.com/> 1.12.0-2mdk
- Rebuild

* Sun Jun 19 2005 Luca Berra <bluca@vodka.it> 1.12.0-1mdk 
- 1.12.0
- removed patches merged upstream

* Mon Jun 13 2005 Luca Berra <bluca@vodka.it> 1.12.0-0.test.1mdk 
- 1.12.0 test
- removed gcc4 patch
- added fix for stacked device when using --auto and udev
- use Require(xxx) instead of PreReq

* Tue May 17 2005 Luca Berra <bluca@vodka.it> 1.11.0-1mdk 
- 1.11.0
- fixed build with gcc4 (p11)
- added man page for mdadm (p12)

* Wed Mar 30 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 1.9.0-3mdk
- rebuilt against latest dietlibc

* Mon Mar 21 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 1.9.0-2mdk
- rebuilt because the binary got lost in cyberspace

* Sun Feb 06 2005 Luca Berra <bluca@vodka.it> 1.9.0-1mdk 
- 1.9.0

* Sat Jan 29 2005 Luca Berra <bluca@vodka.it> 1.9.0-0.pre1.1mdk 
- 1.9.0-pre1
- removed autodev and stacking patches merged upstream

* Sun Jan 23 2005 Luca Berra <bluca@vodka.it> 1.8.0-3mdk 
- updated autodev patch
- fix mdadm -As not starting stacked devices

* Sun Jan 23 2005 Luca Berra <bluca@vodka.it> 1.8.0-2mdk 
- added auto=dev option
- re-enabled device autocreation in mdassemble

* Tue Nov 16 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.8.0-1mdk
- new release
- kill patches 101, 102, 103 and 104 (merged upstream)

* Tue Sep 07 2004 Luca Berra <bluca@vodka.it> 1.7.0-3mdk 
- sync with patches merged upstream
- disable device autocreation in mdassemble for now

* Mon Aug 30 2004 Luca Berra <bluca@vodka.it> 1.7.0-2mdk 
- sync with patches merged upstream
- add raid6/raid10 to mdassemble as well
- mdassemble now supports device autocreation

* Tue Aug 24 2004 Luca Berra <bluca@vodka.it> 1.7.0-1mdk 
- 1.7.0
- build mdassemble on ppc as well
- mdadm daemon creates its own pid file
- convert raidtab in mdadm.conf
- prepare for inclusion of mdmpd

* Sat Jun 05 2004 Luca Berra <bluca@vodka.it> 1.6.0-1mdk 
- 1.6.0

